/* TVOut - abstract base class to implement TV out functionality
**
** Copyright (c) 2004 pinc Software. All Rights Reserved.
*/
#ifndef TVOUT_H
#define TVOUT_H


#include <SupportDefs.h>


class TVOut {
	public:
		TVOut(BMessage &settings);
		virtual ~TVOut();

		virtual status_t InitCheck() = 0;

		virtual status_t SetEnabled(bool enabled) = 0;
		virtual bool IsEnabled() const = 0;

		virtual status_t SetMode(int32 mode) = 0;
		virtual status_t QueryModes(BMessage &modes) = 0;

		virtual void WorkspaceChanged();

		virtual void GetName(char *buffer, size_t bufferSize) = 0;
		virtual void GetInfo(char *buffer, size_t bufferSize) = 0;

		static TVOut *GetTVOut(BMessage &settings);
};

extern TVOut *GetNVidiaTVOut(BMessage &settings);
extern TVOut *GetMatroxTVOut(BMessage &settings);

#endif	/* TVOUT_H */
