/*
**	Copyright 2001 Michael Pfeiffer
*/

#include <stdio.h>
#include <malloc.h>
#include <drivers/module.h>
#include "Transfer.h"
#include "riva_iic.h"

int set_reg(int fd, byte bus, byte dab, byte reg, byte value,
													 riva_data_t *ddata) {
	byte buffer[10];
	int err;

	ddata->iic.buffer = &buffer;
	buffer[0] = dab | WR; 
	buffer[1] = reg | (1 << 7);
	buffer[2] = value;
	err = ioctl(fd, rivaStartIIC, ddata); if (err != B_OK) return err;
	write(fd, ddata, 3);
	return ioctl(fd, rivaStopIIC, ddata);
}
/*
// NOT TESTED. not updated
int set_regs(int fd, byte bus, byte dab, byte reg, byte n, byte *values) {
	byte buffer[255+3];
	int err;
	buffer[0] = bus;
	buffer[1] = dab | WR; 
	buffer[2] = reg | AUTOINC | (1 << 7);
	memcpy(&buffer[3], values, n);
	err = ioctl(fd, rivaStartIIC, &bus); if (err != B_OK) return err;
	write(fd, buffer, 2+n);
	return ioctl(fd, rivaStopIIC, &bus);
}
*/

int get_reg(int fd, byte bus, byte dab, byte reg, byte* value,
													 riva_data_t *ddata) {
	int err;
	byte buffer[10];

	ddata->iic.buffer = &buffer;
	buffer[0] = dab | WR; 
	buffer[1] = reg | (1 << 7); // register  
	// start
	err = ioctl(fd, rivaStartIIC, ddata); if (err != B_OK) return err;
	write(fd, ddata, 2);
	
	buffer[0] = dab | RD;
	// restart
	err = ioctl(fd, rivaStartIIC, ddata); if (err != B_OK) return err;
	write(fd, ddata, 1);

	buffer[0] = 0x00;//ACK level should be set to 0 apparantly for CH.
	 
	read(fd, ddata, 1);
	// stop
	err = ioctl(fd, rivaStopIIC, ddata); if (err != B_OK) return err;
	*value = buffer[0];
	return B_OK;
}

/*
// DOES NOT WORK!!! not updated
int get_regs(int fd, byte bus, byte dab, byte reg, byte n, byte* values) {
	int err;
	byte buffer[255+3];
	buffer[0] = bus; 
	buffer[1] = dab | WR; 
	buffer[2] = reg | AUTOINC | (1 << 7); // start register  
	// start
	err = ioctl(fd, rivaStartIIC, &bus); if (err != B_OK) return err;
	write(fd, buffer, 2);
	
	buffer[1] = dab | RD;
	// restart
	err = ioctl(fd, rivaStartIIC, &bus); if (err != B_OK) return err;
	write(fd, buffer, 1);
	 
	read(fd, buffer, n);
	// stop
	err = ioctl(fd, rivaStopIIC, &bus); if (err != B_OK) return err;
	memcpy(values, &buffer[1], n);
	return B_OK;

}
*/
